<?php

class ControllerModuleImportxx extends Controller
{
    private $error = array();

    public function index()
    {
        $this->load->language('module/import_xx');

        $this->document->setTitle($this->language->get('heading_title'));

        $this->load->model('catalog/import');
        $this->load->model('catalog/manufacturer');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {

            //Вся логика импорта
            if ($_FILES['file']['tmp_name'] !== '') {
                file_put_contents('tmp.xml', file_get_contents($_FILES['file']['tmp_name']));
                //загружаю файл
                $use_errors = libxml_use_internal_errors(true);
                $file = simplexml_load_file('tmp.xml');
                if (false === $file) {
                    $this->error['warning'] = "Фаил импорта содержит серьезные ошибки";
                }
                libxml_clear_errors();
                libxml_use_internal_errors($use_errors);

                //Если опция удаления товара включена
                if (isset($_POST['refresh_all'])) {
                    $this->model_catalog_import->clearAll();
                }
                $new_download_option = false;
                if (isset($_POST['new_download'])) {
                    $new_download_option = true;
                }
                if(isset($file->shop->offers->offer[0]->model)) {
                    $test = (string)$file->shop->offers->offer[0]->model;

                    if ($test !== "") {
                        // Если есть данные о категориях
                        if (isset($file->shop->categories)) {
                            $this->recordCategory($file->shop->categories);
                        }
                    }
                }
                // Если есть данные о товаре
                if (isset($file->shop->offers)) {
                    $this->recordProduct($file->shop->offers, $new_download_option);
                }

                if ($file !== false) {$data['message_success'] = 'Импорт успешно завершен';}

                //$this->response->redirect($this->url->link('extension/module/import_xx', 'token=' . $this->session->data['token'] . '&type=module', true));
            } else {
                //$this->model_setting_setting->editSetting('import_xx', $this->request->post);

                //$this->session->data['success'] = $this->language->get('text_success');

                //$this->response->redirect($this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true));
            }
        }

        $data['version'] = '1.0.0 beta';
        $data['heading_title'] = $this->language->get('heading_title');

        $data['text_edit'] = $this->language->get('text_edit');
        $data['text_enabled'] = $this->language->get('text_enabled');
        $data['text_disabled'] = $this->language->get('text_disabled');

        $data['entry_status'] = $this->language->get('entry_status');

        $data['button_save'] = $this->language->get('button_save');
        $data['button_cancel'] = $this->language->get('button_cancel');

        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'token=' . $this->session->data['token'], true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->url->link('extension/extension', 'token=' . $this->session->data['token'] . '&type=module', true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('module/import_xx', 'token=' . $this->session->data['token'], true)
        );

        $data['action'] = $this->url->link('module/import_xx', 'token=' . $this->session->data['token'], true);

        $data['cancel'] = $this->url->link('extension', 'token=' . $this->session->data['token'] . '&type=module', true);

        if (isset($this->request->post['filter_status'])) {
            $data['filter_status'] = $this->request->post['filter_status'];
        } else {
            $data['filter_status'] = $this->config->get('filter_status');
        }

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('module/import_xx.tpl', $data));
    }

    protected function validate()
    {
        if (!$this->user->hasPermission('modify', 'module/import_xx')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }
        if ($_FILES['file']['tmp_name'] == '') {
            $this->error['warning'] = "Фаил yml не выбран";
        }

        return !$this->error;
    }

    /** Создаем или обновляем категории
     * @param array $data
     */
    private function recordCategory($data)
    {
        //Разбераем массив categories
        foreach ($data->category as $category) {
            if(mb_strlen($category['id']) !== 9 ){break;}
            $id = '1' . $category['id'];
            $parent = $category['parentId'];
            $name = $category;
            //если parent отсутствует занчит это главная категория
            if (isset($parent) === false) {
                $top = 1;
            } else {
                $parent = '1' . $parent;
                $top = 0;
            }
            //проверяем существование категории
            $test_category = $this->model_catalog_import->getCategory($id);

            //Если категория ненайдена то создаем новую категорию
            if ($test_category == []) {
                $data = [
                    'id' => $id,
                    'name' => $category,
                    'description' => '',
                    'meta_title' => '',
                    'meta_h1' => $category,
                    'meta_description' => '',
                    'meta_keyword' => '',
                    'parent_id' => $parent,
                    'top' => $top,
                    'column' => 0,
                    'sort_order' => 0,
                    'status' => 1,
                    'category_store' => [0],
                ];

                $this->model_catalog_import->addCategory($data);
            } else {
                $data = [
                    'id' => $id,
                    'name' => $category,
                    'description' => '',
                    'meta_title' => '',
                    'meta_h1' => $category,
                    'meta_description' => '',
                    'meta_keyword' => '',
                    'parent_id' => $parent,
                    'top' => $top,
                    'column' => 0,
                    'sort_order' => 0,
                    'status' => 1,
                    'category_store' => [0],
                ];

                $this->model_catalog_import->editCategory($id, $data);
            }
        }
    }

    /** Cоздаем или обновляем товар
     * @param $data
     * @return string
     */
    private function recordProduct($data,$new_download_option)
    {
        foreach ($data->offer as $offer) {
            //Проверка на дозагрузку
            if(mb_strlen($offer['id']) !== 9 ){break;}
            if($new_download_option){
                $test_product = $this->model_catalog_import->getProduct("1" . $offer['id']);
                if ($test_product == []) {
                }else{
                    continue;
                }
            }

            // Тест на обновление товара
            $test_product = $this->model_catalog_import->getProduct("1" . $offer['id']);
            if (isset($offer->vendor) === false && isset($offer->param) === false && $test_product !== []) {
                if( isset($offer->price ) && isset($offer['available'] )){
                    $remains = 0;
                    $id = "1" . $offer['id'];
                    $available = $offer['available'];
                    $price = $offer->price;
                    if ($available == 'true') {
                        $remains = 100;
                    }
                        $data_update = [
                            'id' => $id,
                            'price' => $price,
                            'remains' => $remains,
                        ];
                    $this->model_catalog_import->update($data_update);
                }
                continue;
            }
            // Непропускаем обновления для отсутствующих товаров
            if($test_product == [] && isset($offer->vendor) === false && isset($offer->param) === false && isset($offer->model) === false){
                continue;
            }


            // получаем производителя
            $vendor = 0;
            if (isset($offer->vendor)) {
                $test_vendor = $this->model_catalog_import->getManufacturer((string)$offer->vendor);
                if ($test_vendor === []) {
                    //создаем
                    $data_new_vendor = [
                        'name' => (string)$offer->vendor,
                        'description' => '',
                        'meta_keyword' => '',
                        'sort_order' => 0,
                        'manufacturer_store' => [0 => 0],
                    ];
                    $manufacturer_id = $this->model_catalog_import->addManufacturer($data_new_vendor);
                } else {
                    $manufacturer_id = $test_vendor['manufacturer_id'];
                }
            }
            //
            $manufacturer = 0;
            if (isset($manufacturer_id)) {
                $manufacturer = $manufacturer_id;
            }


            // фильтруем поля на наличие критичиских ошибок
            if (isset($offer['id'])) {
                $id = "1" . $offer['id'];
            } else {
                return 'error_product_id';
            }

            $available = 'true';
            if (isset($offer['available'])) {
                $available = $offer['available'];
            }
            if ($available == 'true') {
                $remains = 100;
            } else {
                $remains = 0;
            }

            $name = "Нет названия";
            if (isset($offer->name)) {
                $name = $offer->name;
            } else {
                return 'error_product_name';
            }

            $price = 0;
            if (isset($offer->price)) {
                $price = $offer->price;
            }

            $image = '';
            $images = null;
            if (isset($offer->picture)) {
                $image = (string)$offer->picture[0];
                $images = $offer->picture;
            }
            $product_images = [];
            if (isset($images)) {
                $i = 0;
                foreach ($images as $img) {
                    $product_images[$i] = [
                        'image' => (string)$img, 'sort_order' => 0,
                    ];
                    $i++;
                }
                //
            }

            $model = '000';
            if (isset($offer->vendorCode)) {
                $model = $offer->vendorCode;
            }
            $sku = '';
            if (isset($offer->model)) {
                $sku = $offer->model;
            }
            $description = '';
            if (isset($offer->description)) {
                $description = $offer->description;
            }
            $parent_category = [];
            if (isset($offer->categoryId)) {
                $i = 0;
                foreach ($offer->categoryId as $category_id) {
                    if ((string)$category_id !== '') {
                        $parent_category[$i] = (string)'1' . $category_id;
                        $i++;
                    }
                }
            }

            //Атрибуты
            $data_attribut = [];
            if (isset($offer->param)) {
                $test_attr = $this->model_catalog_import->getAttributeGroup("Свойства товара");
                if ($test_attr == []) {
                    //Создаем группу атрибутов "Свойства товара"
                    $attribute_group_id = $this->model_catalog_import->addAttributeGroup();
                } else {
                    $attribute_group_id = $test_attr['attribute_group_id'];
                }

                $i = 0;
                foreach ($offer->param as $param) {
                    $param_name = $param['name'];
                    $test_attribute_descript = $this->model_catalog_import->getAttribute($param_name);
                    if ($test_attribute_descript == []) {
                        //Создаем атрибут
                        $data = ['name' => $param_name, 'attribute_group_id' => $attribute_group_id];
                        $attribute_id = $this->model_catalog_import->addAttribute($data);
                    } else{
                        $attribute_id = $test_attribute_descript['attribute_id'];
                    }

                    $data_attribut[$i] =[
                        'attribute_id' => $attribute_id,
                        'text' => (string)$param,
                    ];
                    $i++;
                }
            }
            //['product_attribute']

            //проверяем существование товара
            $test_product = $this->model_catalog_import->getProduct($id);

            if ($test_product == []) {
                //создаем товар
                $data = [
                    'id' => $id,
                    'image' => $image,
                    'product_image' => $product_images,
                    'model' => $model,
                    'sku' => $sku,
                    'upc' => '',
                    'ean' => '',
                    'jan' => '',
                    'isbn' => '',
                    'mpn' => '',
                    'location' => '',
                    'quantity' => $remains,
                    'minimum' => 1,
                    'subtract' => 0,
                    'stock_status_id' => 5,
                    'date_available' => '2009-02-03',
                    'manufacturer_id' => $manufacturer,
                    'shipping' => 1,
                    'price' => $price,
                    'points' => 0,
                    'weight' => 0,
                    'weight_class_id' => 1,
                    'length' => 0,
                    'width' => 0,
                    'height' => 0,
                    'length_class_id' => 0,
                    'status' => 1,
                    'tax_class_id' => 0,
                    'sort_order' => 0,
                    'name' => $name,
                    'description' => $description,
                    'tag' => '',
                    'meta_title' => $name,
                    'meta_h1' => $name,
                    'meta_description' => '',
                    'meta_keyword' => '',
                    'product_category' => $parent_category,
                    'product_attribute' => $data_attribut,
                ];
                $this->model_catalog_import->addProduct($data);

            } else {
                // обновляем товар
                $data = [
                    'id' => $id,
                    'image' => $image,
                    'product_image' => $product_images,
                    'model' => $model,
                    'sku' => $sku,
                    'upc' => '',
                    'ean' => '',
                    'jan' => '',
                    'isbn' => '',
                    'mpn' => '',
                    'location' => '',
                    'quantity' => $remains,
                    'minimum' => 1,
                    'subtract' => 0,
                    'stock_status_id' => 5,
                    'date_available' => '2009-02-03',
                    'manufacturer_id' => $manufacturer,
                    'shipping' => 1,
                    'price' => $price,
                    'points' => 0,
                    'weight' => 0,
                    'weight_class_id' => 1,
                    'length' => 0,
                    'width' => 0,
                    'height' => 0,
                    'length_class_id' => 0,
                    'status' => 1,
                    'tax_class_id' => 0,
                    'sort_order' => 0,
                    'name' => $name,
                    'description' => $description,
                    'tag' => '',
                    'meta_title' => $name,
                    'meta_h1' => $name,
                    'meta_description' => '',
                    'meta_keyword' => '',
                    'product_category' => $parent_category,
                    'product_attribute' => $data_attribut,
                ];
                $this->model_catalog_import->editProduct($id, $data);
            }
        }
    }


}